#ifndef _TT_CMAP_H_
#define _TT_CMAP_H_

#include "sfnt.h"

/* TrueType cmap table */
typedef struct
{
  USHORT format;
  USHORT platform;
  USHORT encoding;
  ULONG  language; /* or version, only for Mac */
  void  *map;
} tt_cmap;

/* Paltform ID */
#define TT_MAC 1u
#define TT_WIN 3u
/* Platform-specific encoding ID */
/* Windows */
#define TT_WIN_SYMBOL  0u
#define TT_WIN_UNICODE 1u
#define TT_WIN_SJIS    2u
#define TT_WIN_RPC     3u
#define TT_WIN_BIG5    4u
#define TT_WIN_WANSUNG 5u
#define TT_WIN_JOHAB   6u
/* not supported */
#define TT_WIN_UCS4    12u

/* Mac */
#define TT_MAC_ROMAN               0u
#define TT_MAC_JAPANESE            1u
#define TT_MAC_TRADITIONAL_CHINESE 2u
#define TT_MAC_KOREAN              3u
#define TT_MAC_SIMPLIFIED_CHINESE  25u

extern tt_cmap *tt_cmap_read (sfnt *sfont, USHORT platform, USHORT encoding);

extern USHORT   tt_cmap_lookup (tt_cmap *cmap, USHORT cc);
extern void     tt_cmap_release (tt_cmap *cmap);

#endif /* _TT_CMAP_H_ */
